import'reflect-metadata';import createWebStorage from'redux-persist/lib/storage/createWebStorage.js';import {combineReducers}from'@reduxjs/toolkit';import autoMergeLevel2 from'redux-persist/lib/stateReconciler/autoMergeLevel2.js';import {createEpicMiddleware}from'redux-observable';import {createRouterReducer}from'@common-stack/remix-router-redux';import {persistReducer}from'redux-persist';import {REDUX_PERSIST_KEY,ClientTypes}from'@common-stack/client-core';import {createReduxStore as createReduxStore$1}from'./base-redux-config.js';import {logger}from'../utils/index.js';import features from'../modules.js';import {rootEpic}from'./epic-config.js';const epicMiddlewareFunc = (apolloClient, services, container) => createEpicMiddleware({
    dependencies: {
        apolloClient,
        routes: features.getConfiguredRoutes(),
        services,
        container,
        logger,
    },
});
const createReduxStore = (apolloClient, services, container) => {
    const persistConfig = {
        key: REDUX_PERSIST_KEY,
        storage: typeof window !== 'undefined' ? createWebStorage('local') : null,
        stateReconciler: autoMergeLevel2,
        transforms: features.reduxPersistStateTransformers,
        blacklist: ['router'],
    };
    const reducers = {
        router: createRouterReducer({}),
        ...features.reducers,
    };
    let store;
    if (import.meta.hot?.data?.store) {
        logger.debug('Restoring Redux store from hot reload data');
        store = import.meta.hot.data.store;
        store.replaceReducer(persistReducer(persistConfig, combineReducers(reducers)));
    }
    else {
        let initialState = {};
        let middlewares = [];
        if (typeof window !== 'undefined') {
            initialState = { ...window.__PRELOADED_STATE__ };
            delete window.__PRELOADED_STATE__;
            logger.debug('Loaded initial state from window.__PRELOADED_STATE__');
        }
        store = createReduxStore$1({
            scope: typeof window !== 'undefined' ? 'browser' : 'server',
            isDebug: true,
            isDev: process.env.NODE_ENV === 'development',
            initialState,
            persistConfig,
            middleware: middlewares,
            epicMiddleware: epicMiddlewareFunc(apolloClient, services, container),
            rootEpic: rootEpic,
            reducers,
            reduxConfig: features.getReduxConfig(),
        });
        logger.debug('Created new Redux store');
    }
    if (container.isBound(ClientTypes.ReduxStore)) {
        container
            .rebind(ClientTypes.ReduxStore)
            .toDynamicValue(() => store)
            .inRequestScope();
        logger.debug('Rebound ReduxStore in container');
    }
    else {
        container
            .bind(ClientTypes.ReduxStore)
            .toDynamicValue(() => store)
            .inRequestScope();
        logger.debug('Bound ReduxStore in container');
    }
    return { store };
};export{createReduxStore,epicMiddlewareFunc};